package prefuse.visual.sort;

import cytoPrefuse.CytoPrefuse;
import prefuse.Visualization;
import prefuse.data.Table;
import prefuse.data.column.ColumnMetadata;
import prefuse.visual.AggregateItem;
import prefuse.visual.DecoratorItem;
import prefuse.visual.EdgeItem;
import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;

public class MyRenderSorter extends ItemSorter {

	private Table edges;
    public MyRenderSorter(Table edges) {
    	this.edges = edges;
	}
	public int score(VisualItem item) {
	        int type = ITEM;
	        if ( item instanceof EdgeItem ) {
	            type = EDGE;
	        } else if ( item instanceof AggregateItem ) {
	            type = AGGREGATE;
	        } else if ( item instanceof DecoratorItem ) {
	            type = DECORATOR;
	        }
	        
	        int score = (1<<(26+type));
	        if ( item.isHover() ) {
	            score += (1<<24);
	        }
	        if ( item.isHighlighted() ) {
	            score += (1<<23);
	        }
	        if ( item.isInGroup(CytoPrefuse.SELECTED) ) {
	            score += (1<<22);
	        }
	        if ( item.isInGroup(Visualization.SEARCH_ITEMS) ) {
	            score += (1<<21);
	        }
	        if (item.canGetBoolean(CytoPrefuse.ON_SHORTEST_PATH)){
	        	if (item.getBoolean(CytoPrefuse.ON_SHORTEST_PATH)){
	        	     score += (1<<25);
	      	       
	        	}
	        }
	        if (item.canGetBoolean(CytoPrefuse.ON_PATHWAY)){
	        	if (item.getBoolean(CytoPrefuse.ON_PATHWAY)){
	        	     score += (1<<20);
	      	       
	        	}
	        }
	        if ( item instanceof EdgeItem ) {
	        	//Sort to suppport our pseudo alpha blending.
	        	
	        	EdgeItem edge = (EdgeItem)item;
	        	
	        	ColumnMetadata edgeLengthMetadata = edges.getMetadata(CytoPrefuse.EDGE_LENGTH);
				int maxRow =edgeLengthMetadata.getMaximumRow();					
				float maxLength = edges.getInt(maxRow, CytoPrefuse.EDGE_LENGTH);
				int edgeLength = edge.getInt(CytoPrefuse.EDGE_LENGTH);
			    double normalizedLength= 255*(edgeLength / maxLength);
			   
				//Darker edges should go on top
		        score +=255- normalizedLength;   
	        }
	        
	        if (item instanceof DecoratorItem){
	        	DecoratorItem di = (DecoratorItem)item;
	        	Object o = di.getDecoratedItem();
	        	if (o instanceof NodeItem){
	        		score +=1;
	        	}
	        }

	        return score;
	    }
}
